/*
integrit - file integrity verification system
Copyright (C) 2000 Ed Cashin

You can redistribute this program and/or modify it under the terms of
the Artistic License as published by the Open Source Initiative,
currently at the following URL:

    http://www.opensource.org/licenses/artistic-license.html

THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

*/
#include	<config.h>
#include	<stdlib.h>
#include	"cdb.h"
#include	"buffer.h"
#include	"cdb_make.h"
#include	"uint32.h"

int cdb_put(struct cdb_make *c,
	    unsigned char *key, size_t klen, void *val, size_t vlen)
{
    int			i;
    uint32		h;

    if (cdb_make_addbegin(c, klen, vlen) == -1)
      return -1;
    buffer_put(&c->b, key, klen);
    for (i = 0, h = CDB_HASHSTART; i < klen; ++i)
      h	 = cdb_hashadd(h, key[i]);
    buffer_put(&c->b, val, vlen);
    if (cdb_make_addend(c, klen, vlen, h) == -1)
      return -1;

    return 0;
}

